/* matrizTransicion.c - Matriz de transicion */
#include <stdio.h>
#include <stdlib.h>
#include <string.h>
#include <time.h>

#define NUMNOTAS 4

void MIDI2Note(int MIDI, char Note[]);
int transicion(int j, float matriz[][NUMNOTAS]);

int main(){

	int i, j, k;
	float matriz[NUMNOTAS][NUMNOTAS] = {{0.0, 0.3, 0.0, 0.0}, {1.0, 0.3, 0.3, 0.0}, {0.0, 0.4, 0.6, 0.5}, {0.0, 0.0, 0.1, 0.5}};
	int midi[NUMNOTAS] = {60, 62, 64, 67};
	char Nota[4];

	srand(time(NULL));
	
	printf("Notas MIDI: \n");
	for (i = 0; i < NUMNOTAS; i++){
		printf("%2d\t", midi[i]);
	}
	printf("\n");
	for (i = 0; i < NUMNOTAS; i++){
		MIDI2Note(midi[i],Nota);
		printf("%2s\t", Nota);
	}
	printf("\n");
	printf("\n");
	printf("Matriz de transicion: \n");
	printf("\t");
	for (i = 0; i < NUMNOTAS; i++){
		MIDI2Note(midi[i],Nota);
		printf("%3s \t", Nota);
	}
	printf("\n");

	for (i = 0; i < NUMNOTAS; i++){
		MIDI2Note(midi[i],Nota);
		printf("%2s \t", Nota);
		for (j = 0; j < NUMNOTAS; j++){
			printf("%1.1f\t", matriz[i][j]);
		}
		printf("\n");
	}
	printf("\n");

	j=0; /* Primera nota */
	for (k = 0; k < NUMNOTAS*4; k++){
		printf("%2d ",midi[j]); 
		j = transicion(j, matriz);
	}
	printf("\n");
	
	return 0;
}

// escribe la nota a partir del numero MIDI	
void MIDI2Note(int MIDI, char Note[]){

  int octava, offset;
  char *notas[12] = {"C","C#","D","D#","E","F","F#","G","G#","A","A#","B"};
  char soctava[2];

  octava = MIDI / 12 - 1;
  offset = MIDI % 12;

  sprintf(soctava, "%d", octava);
  strcpy(Note, notas[offset]);
  strcat(Note, soctava);

}

int transicion(int j, float matriz[][NUMNOTAS]){
	float p, umbral = 0;
	int i, num;
	
	p = (float)rand() / RAND_MAX;
	
	for (i = 0; i < NUMNOTAS; i++){
		umbral += matriz[i][j];
		if (p <= umbral)
			return i;
	}
	
}


